## mycompiler.myoperator
Class LogOp

    java.lang.Object
      mycompiler.myoperator.Operator
          mycompiler.myoperator.LogOp

Direct Known Subclasses:
  AndOp, OrOp

    public abstract class LogOp

extends Operator

Constructor Summary
`LogOp()`

Method Summary
`static void` `build(ClassFile classfile, CodeAttribute code, Expr expr, de.dhbwstuttgart.typeinference.Menge indices, boolean not, boolean ex2, boolean and, de.dhbwstuttgart.typeinference.Menge paralist)`
`void` `codegen(ClassFile classfile, CodeAttribute code, Expr expr, boolean not, de.dhbwstuttgart.typeinference.Menge paralist)`
`void` `if_codegen(ClassFile classfile, CodeAttribute code, boolean not, Expr expr, Statement then_block, Statement else_block, de.dhbwstuttgart.typeinference.Menge paralist)`
`void` `loop_codegen(ClassFile classfile, CodeAttribute code, Expr expr, int breakpoint, boolean not, de.dhbwstuttgart.typeinference.Menge paralist)`
`static void` `replace_index(CodeAttribute code, de.dhbwstuttgart.typeinference.Menge indices, int else_index, int then_index)`
`CTripleSet` `TRExp(Binary binary, CSubstitutionSet sigma, CTypeAssumptionSet V, CSupportData supportData)` Achtung Workaround: Wenn die BaseTypes endlich korrekt implementiert sind, dann sollte der RefType "Boolean" �berall durch den BaseType "BooleanType" ersetzt werden!!!

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### LogOp

    public LogOp()

Method Detail

### codegen

    public void codegen(ClassFile classfile,
                        CodeAttribute code,
                        Expr expr,
                        boolean not,
                        de.dhbwstuttgart.typeinference.Menge paralist)
                 throws JVMCodeException

  Specified by:
    `codegen` in class `Operator`
  Throws:
    `JVMCodeException`

### if_codegen

    public void if_codegen(ClassFile classfile,
                           CodeAttribute code,
                           boolean not,
                           Expr expr,
                           Statement then_block,
                           Statement else_block,
                           de.dhbwstuttgart.typeinference.Menge paralist)
                    throws JVMCodeException

  Throws:
    `JVMCodeException`

### loop_codegen

    public void loop_codegen(ClassFile classfile,
                             CodeAttribute code,
                             Expr expr,
                             int breakpoint,
                             boolean not,
                             de.dhbwstuttgart.typeinference.Menge paralist)
                      throws JVMCodeException

  Throws:
    `JVMCodeException`

### build

    public static void build(ClassFile classfile,
                             CodeAttribute code,
                             Expr expr,
                             de.dhbwstuttgart.typeinference.Menge indices,
                             boolean not,
                             boolean ex2,
                             boolean and,
                             de.dhbwstuttgart.typeinference.Menge paralist)
                      throws JVMCodeException

  Throws:
    `JVMCodeException`

### replace_index

    public static void replace_index(CodeAttribute code,
                                     de.dhbwstuttgart.typeinference.Menge indices,
                                     int else_index,
                                     int then_index)
                              throws JVMCodeException

  Throws:
    `JVMCodeException`

### TRExp

    public CTripleSet TRExp(Binary binary,
                            CSubstitutionSet sigma,
                            CTypeAssumptionSet V,
                            CSupportData supportData)

  Achtung Workaround: Wenn die BaseTypes endlich korrekt implementiert sind, dann sollte der RefType "Boolean" �berall durch den BaseType "BooleanType" ersetzt werden!!!
  Author: J�rg B�uerle

  Specified by:
    `TRExp` in class `Operator`
  Parameters:
    `binary` -
    `sigma` -
    `V` -
    `supportData` -
  Returns: